import * as React from 'react';
import { FieldValues, FieldName, FieldErrors, UseFormOptions, OnSubmit, ElementLike, ManualFieldError } from './types';
export declare function useForm<FormValues extends FieldValues = FieldValues>({ mode, reValidateMode, validationSchema, defaultValues, submitFocusError, validateCriteriaMode, }?: UseFormOptions<FormValues>): {
    watch: {
        (): FormValues;
        (option: {
            nest: boolean;
        }): FormValues;
        <T extends FieldName<FormValues>>(field: T & string, defaultValue?: string | undefined): FormValues[T];
        (fields: FieldName<FormValues>[] | string[], defaultValues?: Partial<FormValues> | undefined): Partial<FormValues>;
    };
    control: {
        register: {
            <Element_1 extends ElementLike = ElementLike>(validationOptions: Partial<{
                required: string | boolean | {
                    value: boolean;
                    message: string;
                };
                min: string | number | {
                    value: string | number;
                    message: string;
                };
                max: string | number | {
                    value: string | number;
                    message: string;
                };
                maxLength: string | number | {
                    value: string | number;
                    message: string;
                };
                minLength: string | number | {
                    value: string | number;
                    message: string;
                };
                pattern: RegExp | {
                    value: RegExp;
                    message: string;
                };
                validate: import("./types").Validate | Record<string, import("./types").Validate>;
            }>): (ref: Element_1 | null) => void;
            <Element_2 extends ElementLike = ElementLike>(name: FieldName<FormValues>, validationOptions?: Partial<{
                required: string | boolean | {
                    value: boolean;
                    message: string;
                };
                min: string | number | {
                    value: string | number;
                    message: string;
                };
                max: string | number | {
                    value: string | number;
                    message: string;
                };
                maxLength: string | number | {
                    value: string | number;
                    message: string;
                };
                minLength: string | number | {
                    value: string | number;
                    message: string;
                };
                pattern: RegExp | {
                    value: RegExp;
                    message: string;
                };
                validate: import("./types").Validate | Record<string, import("./types").Validate>;
            }> | undefined): void;
            <Element_3 extends ElementLike = ElementLike>(namesWithValidationOptions: Record<FieldName<FormValues>, Partial<{
                required: string | boolean | {
                    value: boolean;
                    message: string;
                };
                min: string | number | {
                    value: string | number;
                    message: string;
                };
                max: string | number | {
                    value: string | number;
                    message: string;
                };
                maxLength: string | number | {
                    value: string | number;
                    message: string;
                };
                minLength: string | number | {
                    value: string | number;
                    message: string;
                };
                pattern: RegExp | {
                    value: RegExp;
                    message: string;
                };
                validate: import("./types").Validate | Record<string, import("./types").Validate>;
            }>>): void;
            <Element_4 extends ElementLike = ElementLike>(ref: Element_4, validationOptions?: Partial<{
                required: string | boolean | {
                    value: boolean;
                    message: string;
                };
                min: string | number | {
                    value: string | number;
                    message: string;
                };
                max: string | number | {
                    value: string | number;
                    message: string;
                };
                maxLength: string | number | {
                    value: string | number;
                    message: string;
                };
                minLength: string | number | {
                    value: string | number;
                    message: string;
                };
                pattern: RegExp | {
                    value: RegExp;
                    message: string;
                };
                validate: import("./types").Validate | Record<string, import("./types").Validate>;
            }> | undefined): void;
        };
        unregister: {
            (name: FieldName<FormValues>): void;
            (names: FieldName<FormValues>[]): void;
        };
        setValue: <Name extends FieldName<FormValues>>(name: Name, value: FormValues[Name], shouldValidate?: boolean | undefined) => void | Promise<boolean>;
        formState: {
            dirty: boolean;
            isSubmitted: boolean;
            submitCount: number;
            touched: FieldName<FormValues>[];
            isSubmitting: boolean;
            isValid: boolean;
        };
        mode: {
            isOnBlur: boolean;
            isOnSubmit: boolean;
        };
        reValidateMode: {
            isReValidateOnBlur: boolean;
            isReValidateOnSubmit: boolean;
        };
        errors: FieldErrors<FormValues>;
        defaultValues: Partial<FormValues> | FormValues[FieldName<FormValues>];
    };
    handleSubmit: (callback: OnSubmit<FormValues>) => (e: React.BaseSyntheticEvent<object, any, any>) => Promise<void>;
    reset: (values?: Partial<FormValues> | undefined) => void;
    setValue: <Name extends FieldName<FormValues>>(name: Name, value: FormValues[Name], shouldValidate?: boolean | undefined) => void | Promise<boolean>;
    triggerValidation: (payload?: string | FieldName<FormValues> | FieldName<FormValues>[] | undefined, shouldRender?: boolean | undefined) => Promise<boolean>;
    getValues: (payload?: {
        nest: boolean;
    } | undefined) => FormValues;
    register: {
        <Element_1 extends ElementLike = ElementLike>(validationOptions: Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }>): (ref: Element_1 | null) => void;
        <Element_2 extends ElementLike = ElementLike>(name: FieldName<FormValues>, validationOptions?: Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }> | undefined): void;
        <Element_3 extends ElementLike = ElementLike>(namesWithValidationOptions: Record<FieldName<FormValues>, Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }>>): void;
        <Element_4 extends ElementLike = ElementLike>(ref: Element_4, validationOptions?: Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }> | undefined): void;
    };
    unregister: {
        (name: FieldName<FormValues>): void;
        (names: FieldName<FormValues>[]): void;
    };
    clearError: {
        (): void;
        (name: FieldName<FormValues>): void;
        (names: FieldName<FormValues>[]): void;
    };
    setError: {
        (name: ManualFieldError<FormValues>[]): void;
        (name: FieldName<FormValues>, type: Record<string, import("./types").ValidateResult>): void;
        (name: FieldName<FormValues>, type: string, message?: string | undefined): void;
    };
    errors: FieldErrors<FormValues>;
    formState: {
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: FieldName<FormValues>[];
        isSubmitting: boolean;
        isValid: boolean;
    };
};
